
; Scanner le clavier pour savoir si le joueur pose une bombe 
BOMB_SCAN_KEY:
	push hl
	push de
	push bc
	ld     a,$FF          
        out    (1),a           
	ld     a,$FD       	; scanner le groupe pour les bombes     
	out    (1),a         
	in     a,(1)        
	;bit	0,a
	cp	191
	jp	z, drop_bomb
	cp	254
	jp	z, mort1
	jp	dropend

mort1:
	ld	a, 1
	ld	(mort_flag), a
	jp	dropend
	
drop_bomb:
	call	BOMB_UPDATE_MULT
dropend:
	pop	bc
	pop	de
	pop	hl

	ret



; sauver une bombe, s'il reste de la place dans la liste (un emplacement [0,0])
BOMB_UPDATE_MULT:
	push hl
	push de
	push bc

	ld	b, 8 
	ld	hl,xbomblist
	ld	de,ybomblist
	
bomb_update_loop:
	ld	a, (hl)
	cp	0
	jp	z, save_bomb
	inc	hl
	inc	de
	djnz 	bomb_update_loop
	jp	save_end

save_bomb:
	;ld	a, (xcoord)
	;ld	(hl), a
	;ld	a, (ycoord)
	;ld	(de), a

	call	BOMB_PLACE

	; on recopie les bonnes valeurs dans les listes		
	ld	a, (xbomb)
	ld	(hl), a
	ld	a, (ybomb)
	ld	(de), a

	; timer
	; recuperer le decalage dans de
	ld	a, 8
	sub	b
	ld	d, 0
	ld	e, a
	ld	hl,tbomblist
	add	hl, de
	ld	(hl), 127 ; la duree avant explosion

	
save_end:	
	pop	bc
	pop	de
	pop	hl

	ret

; Placer une bombe sur une case (peut etre ameliore avec un decalage cad modulo)
BOMB_PLACE:
	push hl
	push de
	push bc

	ld	a, (xcoord)
	cp	9
	jp	m, xmoins8
	cp	17
	jp	m, xmoins16
	cp 	25
	jp	m, xmoins24
	cp 	33
	jp	m, xmoins32
	cp 	41
	jp	m, xmoins40
	cp 	49
	jp	m, xmoins48
	cp 	57
	jp	m, xmoins56
	cp 	65
	jp	m, xmoins64
	cp 	73
	jp	m, xmoins72
	cp 	81
	jp	m, xmoins80
	cp 	89
	jp	m, xmoins88
	
	

xmoins8:
	ld	a, 8
	jp	finx
xmoins16:
	ld	a, 16
	jp	finx
xmoins24:
	ld	a, 24
	jp	finx
xmoins32:
	ld	a, 32
	jp	finx
xmoins40:
	ld	a, 40
	jp	finx
xmoins48:
	ld	a, 48
	jp	finx
xmoins56:
	ld	a, 56
	jp	finx
xmoins64:
	ld	a, 64
	jp	finx
xmoins72:
	ld	a, 72
	jp	finx
xmoins80:
	ld	a, 80
	jp	finx
xmoins88:
	ld	a, 88
	jp	finx

finx:
	ld	hl, xbomb
	ld	(hl), a



	ld	a, (ycoord)
	cp	5
	jp	m, ymoins4
	cp	13
	jp	m, ymoins12
	cp 	21
	jp	m, ymoins20
	cp 	29
	jp	m, ymoins28
	cp 	37
	jp	m, ymoins36
	cp 	45
	jp	m, ymoins44
	cp 	53	
	jp	m, ymoins52
	cp 	61	
	jp	m, ymoins60
	
	
	

ymoins4:
	ld	a, 4
	jp	finy
ymoins12:
	ld	a, 12
	jp	finy
ymoins20:
	ld	a, 20
	jp	finy
ymoins28:
	ld	a, 28
	jp	finy
ymoins36:
	ld	a, 36
	jp	finy
ymoins44:
	ld	a, 44
	jp	finy
ymoins52:
	ld	a, 52
	jp	finy
ymoins60:
	ld	a, 52
	jp	finy

finy:
	ld	de, ybomb
	ld	(de), a
	

	pop	bc
	pop	de
	pop	hl

	ret

; Decrementer tout ce qu'il y a a decrementer
; Faire exploser une bombe s'il y a lieu (timer == 10)
; Faire disparaitre la bombe s'il y a lieu (timer == 1)

BOMB_DEC_TIMER:
	push hl
	push de
	push bc

	ld	b, 8 
	ld	hl,tbomblist
	
dec_timer:
	ld	a, (hl)
	cp	1
	jp	p, dec
	jp	no_dec
dec:
	dec	a
	cp	1
	jp	z, bmcl	; boum
	ld	(hl), a ; sinon decrementer
	cp	30
	jp	z, bm
	jp	no_dec

; on etait a 10, on va exploser
bm:
	call	PREPARE_BOUM
	jp	no_dec
	

; on etait a 1, on va disparaitre
bmcl:
	call	PREPARE_BOUM_CLEAN
	ld	(hl), 0

no_dec:
	inc	hl
	djnz	dec_timer
	
	pop	bc
	pop	de
	pop	hl
	
	ret




; mettre a 0 les valeur x et y des bombes qui doivent disparaitre
; hl = adress du timer
; b = 8 - decalage
; donc 8 - b = decalage
; faire disparaitre la bombe
PREPARE_BOUM:
	push hl
	push de
	push bc

	
	ld	a, 8
	sub	b
	ld	d, 0
	ld	e, a
	push 	de
	ld	hl, xbomblist
	add	hl, de
	ld	a, (hl)
	ld	(xbomb), a

	pop	de
	ld	hl, ybomblist
	add	hl, de
	ld	a, (hl)
	ld	(ybomb), a
	call	BOMB_CLR
	call	BOMB_EXPLOSE

	pop	bc
	pop	de
	pop	hl

	ret


PREPARE_BOUM_CLEAN:
	push hl
	push de
	push bc

	
	ld	a, 8
	sub	b
	ld	d, 0
	ld	e, a
	push 	de
	ld	hl, xbomblist
	add	hl, de
	ld	a, (hl)
	ld	(xbomb), a

	pop	de
	ld	hl, ybomblist
	add	hl, de
	ld	a, (hl)
	ld	(ybomb), a
	call	BOMB_CLR
	
set_xy_zero:
	ld	a, 8
	sub	b
	push	af
	ld	d, 0
	ld	e, a
	ld	hl,xbomblist
	add	hl, de
	ld	(hl), 0 ; mettre x a 0
	pop	af
	ld	d, 0
	ld	e, a
	ld	hl,ybomblist
	add	hl, de
	ld	(hl), 0 ; mettre y a 0

	call	BUFCOPY
	call	BOMB_EXPLOSE_CLEAN
	
	pop	bc
	pop	de
	pop	hl

	ret





; On recupere le valeur de x et y de la bombe
; On teste sur quelle rail elle est
; Si elle est sur un rail y libre boum y
; Si elle est sur un rail x libre boum x
; Avant d'afficher le sprite on verifie que l'emplacement n'est pas hors arene
; A l'explosion on verifie que le joueur n'est pas sous le sprite a afficher
BOMB_EXPLOSE:
	push	hl
	push	de
	push	bc

test_x:
	ld	hl, (xbomb)
	ld	a, l
        cp      16             
	jp	z, xlibre
        cp      32            
	jp	z, xlibre
        cp      48           
	jp	z, xlibre
        cp      64          
	jp	z, xlibre
        cp      80          
	jp	z, xlibre
	jp	test_y

xlibre:	

	ld	a, (xbomb)
	ld	hl, xboum
	ld	(hl), a	

	; le y en dessous
	ld	a, (ybomb)
	add 	a,8
	ld	hl, yboum
	ld	(hl), a	
	call	TEST_MORT
	call	BOMB_BOUM

	; le y en dessus
	ld	a, (ybomb)
	sub 	8
	ld	hl, yboum
	ld	(hl), a	
	call	TEST_MORT
	call	BOMB_BOUM



test_y:

	ld	de, (ybomb)
	ld	a, e
	cp      12         
	jp	z, ylibre
        cp      28        
	jp	z, ylibre
        cp      44       
	jp	z, ylibre
	jp	nixniy


ylibre:
	ld	a, (ybomb)
	ld	hl, yboum
	ld	(hl), a	

	; le x en dessous
	ld	a, (xbomb)
	add 	a,8
	ld	hl, xboum
	ld	(hl), a
	call	TEST_MORT
	call	BOMB_BOUM

	; le x en dessus
	ld	a, (xbomb)
	sub 	8
	ld	hl, xboum
	ld	(hl), a	
	call	TEST_MORT
	call	BOMB_BOUM

	
nixniy:

	pop	bc
	pop	de
	pop	hl
	
	ret

TEST_MORT:
	push	hl
	push	de
	push	bc

	ld	a, (xcoord)
	ld	b, a
	ld	a, (xboum)
	sub	1
	cp	b
	jp	p, pas_mort

	ld	a, (xcoord)
	ld	b, a
	ld	a, (xboum)
	add	a, 9
	cp	b
	jp	m, pas_mort


	ld	a, (ycoord)
	ld	b, a
	ld	a, (yboum)
	sub	1
	cp	b
	jp	p, pas_mort

	ld	a, (ycoord)
	ld	b, a
	ld	a, (yboum)
	add	a, 9
	cp	b
	jp	m, pas_mort


mortmort:
	ld	a, 1
	ld	(mort_flag), a
	pop	bc
	pop	de
	pop	hl


pas_mort:
	pop	bc
	pop	de
	pop	hl

	ret


BOMB_EXPLOSE_CLEAN:
	push	hl
	push	de
	push	bc

test_xcl:
	ld	hl, (xbomb)
	ld	a, l
        cp      16             
	jp	z, xlibrecl
        cp      32            
	jp	z, xlibrecl
        cp      48           
	jp	z, xlibrecl
        cp      64          
	jp	z, xlibrecl
        cp      80          
	jp	z, xlibrecl
	jp	test_ycl

xlibrecl:	

	ld	a, (xbomb)
	ld	hl, xboum
	ld	(hl), a	

	; le y en dessous
	ld	a, (ybomb)
	add 	a,8
	ld	hl, yboum
	ld	(hl), a	
	call	BOMB_BOUM_CLEAN

	; le y en dessus
	ld	a, (ybomb)
	sub 	8
	ld	hl, yboum
	ld	(hl), a	
	call	BOMB_BOUM_CLEAN



test_ycl:

	ld	de, (ybomb)
	ld	a, e
	cp      12         
	jp	z, ylibrecl
        cp      28        
	jp	z, ylibrecl
        cp      44       
	jp	z, ylibrecl
	jp	nixniycl


ylibrecl:
	ld	a, (ybomb)
	ld	hl, yboum
	ld	(hl), a	

	; le x en dessous
	ld	a, (xbomb)
	add 	a,8
	ld	hl, xboum
	ld	(hl), a
	call	BOMB_BOUM_CLEAN

	; le x en dessus
	ld	a, (xbomb)
	sub 	8
	ld	hl, xboum
	ld	(hl), a	
	call	BOMB_BOUM_CLEAN
	
nixniycl:

	pop	bc
	pop	de
	pop	hl
	
	ret
	




BOMB_BOUM:

	; tester si on est hors arene
	; Si oui pas d'explosion	
	ld	a, (xboum)
	cp	8
	jp	m, pas_boum
	ld	a, (xboum)
	cp	81
	jp	p, pas_boum
	ld	a, (yboum)
	cp	3
	jp	m, pas_boum
	ld	a, (yboum)
	cp	45
	jp	p, pas_boum

	ld	hl, xboum
	ld	de, yboum
	ld	a, (de)
	ld	e, a
	ld	a, (hl)
	ld	l,a
	ld	hl, boum
	call	CLRSPR

	ld	hl, xboum
	ld	de, yboum
	ld	a, (de)
	ld	e, a
	ld	a, (hl)
	ld	l,a
	ld	hl, boum
	call	DRWSPR

pas_boum:

	ret
	
BOMB_BOUM_CLEAN:
	
	
	; tester si on est hors arene
	; Si oui on ne doit pas effacer	
	ld	a, (xboum)
	cp	8
	jp	m, pas_clean
	ld	a, (xboum)
	cp	81
	jp	p, pas_clean
	ld	a, (yboum)
	cp	3
	jp	m, pas_clean
	ld	a, (yboum)
	cp	45
	jp	p, pas_clean

	ld	hl, xboum
	ld	de, yboum
	ld	a, (de)
	ld	e, a
	ld	a, (hl)
	ld	l,a
	ld	hl, black
	call	CLRSPR
pas_clean:

	ret

	
; Mettre tous les emplacement de la liste de bombe a 0
; FIXME : INUTILE ????? (car deja 0)
BOMB_INIT_MULT:
	push	hl
	push	de
	push	bc

	ld	b, 8
	ld	hl, xbomblist
	ld	de, ybomblist
	ld	c, 0
	
bomb_loop:
	ld	(hl), 0 ; copier y	
	ld	a, c
	ld	(de), a ; copier x
	;add	a,8
	ld	c, a
	
	ld	a, 0
	
	inc	hl
	inc	de
	djnz	bomb_loop
	
	pop	bc
	pop	de
	pop	hl

	ret

; afficher la bombe de coordonnee xbomb et ybomb
BOMB_PRINT:
	push	hl
	push	de
	push	bc

	ld	hl,(xbomb)
	ld	de,(ybomb)
	ld	a, l
	cp	0	; Valeur par defaut , donc on ne fait rien
	jp	z, bomb_print_end
	ld	hl, bomb
	call	DRWSPR

bomb_print_end:
	pop	bc
	pop	de
	pop	hl

	ret



; afficher toutes les bombes de la liste xbomblist et ybomblist
BOMB_PRINT_MULT:
	push	hl
	push	de
	push	bc

	ld	b, 8
	ld	hl,xbomblist
	ld	de,ybomblist

bomb_print_loop:
	ld	a, (hl)	
	ld	(xbomb), a
	ld	a, (de)
	ld	(ybomb), a
	call	BOMB_PRINT
	inc	hl
	inc	de
	djnz	bomb_print_loop

	pop	bc
	pop	de
	pop	hl

fin:

	ret

; effacer la bombe aux coordonnees xbomb et ybomb
BOMB_CLR:
	push	hl
	push	de
	push	bc

	ld	hl,(xbomb)
	ld	de,(ybomb)
	ld	a, l
	ld	hl, black
	call	CLRSPR
	call	BUFCOPY
	
	pop	bc
	pop 	de
	pop	hl
	
	ret

; mettre des valeurs par defaut dans xbomb et ybomb
BOMB_INIT:

	push	hl
	push	de

	ld	hl, 16
	ld	de, 28
	ld	(xbomb), hl
	ld	(ybomb), de	 
	
	pop	de
	pop	hl

	ret

explose_flag:
	.db 0

xbomblist:
	.db 0,0,0,0,0,0,0,0

ybomblist:
	.db 0,0,0,0,0,0,0,0

; Le timer correspondant (pour l'explosion)
; s'il tombe a zero, explosion puis mise a zero de x et y
tbomblist:
	.db 0,0,0,0,0,0,0,0
