IA_CORE:

	push	hl
	push	de
	push	bc
	
	ld	a, (iaxcoord)
	cp	20
	jp	m, IA_DEMI_TOUR	
	cp	45
	jp	p, IA_DEMI_TOUR	
	ld	a, (iaycoord)
	cp	4
	jp	m, IA_DEMI_TOUR	
	cp	52
	jp	p, IA_DEMI_TOUR	

	ld	a, (iaxcoord)
        cp      16             
        jp      z,okx
        cp      32            
        jp      z,okx
        cp      48           
        jp      z,okx
        cp      64          
        jp      z,okx
        cp      80          
        jp      z,okx
	
	jp	fin_demitour

okx:
	
	ld	a, (iaycoord)
	cp      12         
        jp      z,oky
        cp      28        
        jp      z,oky
        cp      44       
        jp      z,oky
	jp	fin_demitour
	
oky: 	
	jp	IA_CHANGE




IA_DEMI_TOUR:

	ld	a, (ia_key)
	cp	1
	jp	z, mettre2
	cp	2
	jp	z, mettre1
	cp	3
	jp	z, mettre4
	cp	4
	jp	z, mettre3

mettre1:
	ld	a, 1
	ld	(ia_key), a
	jp	fin_demitour
mettre2:
	ld	a, 2
	ld	(ia_key), a
	jp	fin_demitour
mettre3:
	ld	a, 3
	ld	(ia_key), a
	jp	fin_demitour
mettre4:
	ld	a, 4
	ld	(ia_key), a
	jp	fin_demitour

fin_demitour:
	pop	bc
	pop	de
	pop	hl

	ret
	
	
IA_CHANGE:
	ld	a, (ia_key)
	cp	1
	jp	z, mettre4
	cp	2
	jp	z, mettre3
	

	ld	a, (ia_key)
	cp	3
	jp	z, mettre1
	cp	4
	jp	z, mettre2


fin_passer:

	pop	bc
	pop	de
	pop	hl

	ret
	




; give a start position to player
IA_MOVE_INIT:
	; init the start position
	push hl
	push de
	
	ld	hl, ghostface
	ld	de, ghost	
	call	COPYSPR
	ld hl, 32
	ld (iaxcoord), hl
	ld (iaoldxcoord), hl
	ld de, 32
	ld (iaycoord), de
	ld (iaoldycoord), de
	ld	a, 1
	ld	(ia_key),a

	pop de
	pop hl

	ret

;; Scan key using direct input
IA_SCAN_KEY:
	push hl
	push de
	push bc
	call 	BUFCOPY

	call	IA_CORE	
	ld	a,(ia_key)
	cp	1
	jp	z, ia_top
	cp	2
	jp	z, ia_bot
	cp	3
	jp	z, ia_right
	cp	4
	jp	z, ia_left
	
ia_top:
	ld	hl, ghostdos
	;ld	hl, ghostdos
	ld	de, ghost	
	call	COPYSPR
	ld hl,(iaycoord)
	dec hl
	ld (iaycoord),hl
	jp ia_print
ia_bot:
	ld	hl, ghostface
	;ld	hl, ghostface
	ld	de, ghost	
	call	COPYSPR
	ld hl,(iaycoord)
	inc hl
	ld (iaycoord),hl
	jp ia_print
ia_right:
	ld	hl, ghostdroite
	;ld	hl, ghostdroit
	ld	de, ghost	
	call	COPYSPR
	ld hl,(iaxcoord)
	inc hl
	ld (iaxcoord),hl
	jp ia_print
ia_left:
	ld	hl, ghostgauche
	;ld	hl, ghostgauche
	ld	de, ghost	
	call	COPYSPR
	ld hl,(iaxcoord)
	dec hl
	ld (iaxcoord),hl
	jp ia_print

; Passe ici seulement si key press
ia_print:
	ld	hl,(iaxcoord)
	ld 	de,(iaycoord)
	ld	a,l
	call	IA_PROTECT_ARENA
	call	IA_PROTECT_BLOCK

	; effacer la tout le sprite (on l'affichera un pixel plus loin apres)	
	ld	hl,(iaoldxcoord)
	ld 	de,(iaoldycoord)
	ld	a,l
	ld	hl,black
	call	CLRSPR
	call	BOMB_PRINT_MULT
	call 	BUFCOPY

	
	; afficher nouveau sprite
	ld 	hl,(iaxcoord)
	ld 	de,(iaycoord)
	ld 	(iaoldxcoord),hl
	ld 	(iaoldycoord),de
	ld 	a,l
	ld 	hl,ghost
	call 	DRWSPR
	call 	BUFCOPY

ia_finloop:
	pop 	bc
	pop 	de
	pop	hl
	
	ret


IA_PROTECT_ARENA:

	push	hl
	push	de
	ld	hl,(iaxcoord)
	ld	a, l
	cp 	7
	jp	m, hors_arene
	cp	81
	jp	p, hors_arene
	ld	hl,(iaycoord)
	ld	a, l
	cp 	3
	jp	m, hors_arene
	cp	54
	jp	p, hors_arene

	jp	place_valide

; Ah on sort de l'arene
; Alors faire machine arriere
ia_hors_arene:
	ld	hl, (iaoldxcoord)
	ld	de, (iaoldycoord)
	ld	(iaxcoord), hl
	ld	(iaycoord), de

ia_place_valide:
	pop	de
	pop	hl

	
	ret


; Tester si on essaie d'aller sur un block
; Si on sort de son couloir on ne fait rien 
; Sinon on peut copier les nouvelles coordonnées
IA_PROTECT_BLOCK:
	push 	hl
	push 	de

	ld	hl, (iaxcoord)
	ld	a, l
        cp      16             
        jp      z,ia_valid_move
        cp      32            
        jp      z,ia_valid_move
        cp      48           
        jp      z,ia_valid_move
        cp      64          
        jp      z,ia_valid_move
        cp      80          
        jp      z,ia_valid_move
	
	ld	hl, (iaycoord)
	ld	a, l
        jp      z,ia_valid_move
	cp      12         
        jp      z,ia_valid_move
        cp      28        
        jp      z,ia_valid_move
        cp      44       
        jp      z,ia_valid_move

	
; Ah on va sur un rocher
; Alors faire machine arriere
ia_invalid_move:
	ld	hl, (iaoldxcoord)
	ld	de, (iaoldycoord)
	ld	(iaxcoord), hl
	ld	(iaycoord), de

ia_valid_move:
	pop 	de
	pop 	hl

	ret




















;/===========================RANDOM Routine=================================\

;|					  			            |

;|	Input: 		b=upper bound 		                     	    |

;|		   	c=lower bound                                	    |

;|			d=sign wanted (0=Positive , 1=Negative)       	    |

;|								      	    |

;|	Output:		op1=integer number between 		     	    |

;|		   	upper bound and lower bound      	     	    |

;|								     	    |

;|  Coded by: Goncalo Almeida	   Version 1.1	   mail: jnalmeida@usa.net  |

;|								     	    |

;|  Use this "at will", as long as you give me some credit.                 |

;|								     	    |

;\==========================================================================/

RANDOM_ROUTINE:

	push de			;saves wanted sign

	push bc			;saves range

	call _zerooop1		;clears op1

	call _random		;generates random number ranging 0-1 in op1



	pop bc			;loads range

	ld a,b			;

	sub c			;subtracts upper bound and lower bound



	push bc			;saves range

	call _setxxop2		;puts the difference to op2

	call _FPmult		;multiplies op1 and op2

	call _Int		;converts op1 to integer

	pop bc			;loads range again	

	ld a,c			;



	call _setxxop2		;puts lower bound to op2

	call _FPADD		;adds op1 and op2

	

	pop de			;loads wanted sign

	ld a,d			;

	

	cp 0			;Sign wanted=positive?

	jp z,RANDOM_ROUTINE_END	;If yes , go to the end



	call _invop1S		;If no, negate op1



RANDOM_ROUTINE_END:

	ret			;returns to program

;============================RANDOM Routine==================================
