
; give a start position to player
MOVE_INIT:
	; init the start position
	push hl
	push de
	
	ld	hl, bomberface
	ld	de, bomber	
	call	COPYSPR
	ld hl, 16
	ld (xcoord), hl
	ld (oldxcoord), hl
	ld de, 12
	ld (ycoord), de
	ld (oldycoord), de

	pop de
	pop hl

	ret

;; Scan key using direct input
SCAN_KEY:
	push hl
	push de
	push bc
	call	BOMB_SCAN_KEY
	call	BOMB_DEC_TIMER
	call	BOMB_PRINT_MULT
	call 	BUFCOPY
	;ld     a,$FF            ; Before any action, reset the keyport
        ;out    (1),a            ; ...by sending to the port 1 the value 255 (FF
	ld     a,$FE            ; select the keyboard group to scan (here the arrow keys)
	out    (1),a            ; ...by sending to the keyboard port (1) the value FE.
	in     a,(1)            ; Get the port value, which says wich keys was pressed 
	cp     254              ;\
	jp     z,bot            ;|
	cp     253              ;| Look for the key which was pressed and jump to the correct label. 
	jp     z,left           ;|
	cp     251              ;|
	jp     z,right          ;|
	cp     247              ;|
	jp     z,top           ;/
	
	jp finloop
	
; Tester la touche pressee	
top:
	ld	hl, bomberdos
	;ld	hl, ghostdos
	ld	de, bomber	
	call	COPYSPR
	ld hl,(ycoord)
	dec hl
	ld (ycoord),hl
	jp print
bot:
	ld	hl, bomberface
	;ld	hl, ghostface
	ld	de, bomber	
	call	COPYSPR
	ld hl,(ycoord)
	inc hl
	ld (ycoord),hl
	jp print
right:
	ld	hl, bomberdroite
	;ld	hl, ghostdroit
	ld	de, bomber	
	call	COPYSPR
	ld hl,(xcoord)
	inc hl
	ld (xcoord),hl
	jp print
left:
	ld	hl, bombergauche
	;ld	hl, ghostgauche
	ld	de, bomber	
	call	COPYSPR
	ld hl,(xcoord)
	dec hl
	ld (xcoord),hl
	jp print

; Passe ici seulement si key press
print:
	ld	hl,(xcoord)
	ld 	de,(ycoord)
	ld	a,l
	call	PROTECT_ARENA
	call	PROTECT_BLOCK

	; effacer la tout le sprite (on l'affichera un pixel plus loin apres)	
	ld	hl,(oldxcoord)
	ld 	de,(oldycoord)
	ld	a,l
	ld	hl,black
	call	CLRSPR
	call	BOMB_PRINT_MULT
	call 	BUFCOPY

	
	; afficher nouveau sprite
	ld 	hl,(xcoord)
	ld 	de,(ycoord)
	ld 	(oldxcoord),hl
	ld 	(oldycoord),de
	ld 	a,l
	ld 	hl,bomber
	call 	DRWSPR
	call 	BUFCOPY
finloop:
	pop 	bc
	pop 	de
	pop	hl
	
	ret


PROTECT_ARENA:

	push	hl
	push	de
	ld	hl,(xcoord)
	ld	a, l
	cp 	7
	jp	m, hors_arene
	cp	81
	jp	p, hors_arene
	ld	hl,(ycoord)
	ld	a, l
	cp 	3
	jp	m, hors_arene
	cp	54
	jp	p, hors_arene

	jp	place_valide

; Ah on sort de l'arene
; Alors faire machine arriere
hors_arene:
	ld	hl, (oldxcoord)
	ld	de, (oldycoord)
	ld	(xcoord), hl
	ld	(ycoord), de

place_valide:
	pop	de
	pop	hl

	
	ret


; Tester si on essaie d'aller sur un block
; Si on sort de son couloir on ne fait rien 
; Sinon on peut copier les nouvelles coordonnées
PROTECT_BLOCK:
	push 	hl
	push 	de

	ld	hl, (xcoord)
	ld	a, l
        cp      16             
        jp      z,valid_move
        cp      32            
        jp      z,valid_move
        cp      48           
        jp      z,valid_move
        cp      64          
        jp      z,valid_move
        cp      80          
        jp      z,valid_move
	
	ld	hl, (ycoord)
	ld	a, l
        jp      z,valid_move
	cp      12         
        jp      z,valid_move
        cp      28        
        jp      z,valid_move
        cp      44       
        jp      z,valid_move

	
; Ah on va sur un rocher
; Alors faire machine arriere
invalid_move:
	ld	hl, (oldxcoord)
	ld	de, (oldycoord)
	ld	(xcoord), hl
	ld	(ycoord), de

valid_move:
	pop 	de
	pop 	hl

	ret



















